config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root 'posts#index'

  resources :users, only: [:show] do
    member do
      post :follow
      post :unfollow
    end

    resources :posts, except: [:index] do
      resources :likes do
        member do
          post :up
          post :down
        end
      end

      collection do
        get :subscriptions
      end

      resources :comments, only: [:create,:destroy]
    end

  end

  resources :posts, only: [] do
    resources :likes, only: [] do
      collection do
        post :up
        delete :down
      end
    end
  end

end

app/models/post.rb
class Post < ApplicationRecord
  belongs_to :user
  has_many_attached :images
  has_many :comments, :dependent => :destroy
  has_many :likes, :dependent => :destroy
  has_many :users, through: :likes

  validates :images, attached: true, content_type: ['image/png', 'image/jpg', 'image/jpeg']
  validate :check_limit_for_edit_post, :on => :update

  def check_limit_for_edit_post
    if Time.new > self.created_at + 15.minutes
      errors.add(:post,"Can't edit after 15 minutes of creating post!")
    end
  end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :authenticate_user!, only: [:edit, :new, :update, :delete]
  before_action :set_post, only: [:show, :edit, :update, :destroy]
  before_action :set_user, only: [:create, :show, :update, :destroy]
  before_action :check_current_user_with_post_user, only: [:update, :destroy]

  def index
    @posts = Post.all.reverse_order
  end

  def show
    @comment = Comment.new
    @comments = @post.comments
  end

  def new
    @post = Post.new
  end

  def edit
    check_limit_time_for_edit_post
  end

  def create
    @post = @user.posts.build(post_params)

    @post.images.attach(params[:post][:images])
    if @post.save
      flash[:success] = 'Post was successfully created.'
      redirect_to user_path(@user)
    else
      render :new
    end
  end

  def update
    if @post.update(post_params)
      upload_images
      flash[:success] = 'Post was successfully update.'
      redirect_to user_post_path(@user.id, @post)
    else
      render :edit
    end
  end

  def destroy
    @post.destroy
    flash[:success] = 'Post was successfully destroy.'
    redirect_to @user
  end

  def subscriptions
    @subscriptions = current_user.followings
    @posts = Post.all.where(user_id: @subscriptions.ids).order(created_at: 'desc')
  end

  def upload_images
    if params[:post][:change_all] && params[:post][:change_all] == "1"
      @post.images.purge
    end
    @post.images.attach(params[:post][:images]) if params[:post][:images].present?
  end

  private
  def check_current_user_with_post_user
    unless current_user == @user && @post.user == @user
      flash[:danger] = 'Incorect user!'
      redirect_back(fallback_location: root_path )
    end
  end

  def check_limit_time_for_edit_post
    if Time.new > @post.created_at + 15.minutes
      flash[:danger] = "You can't edit post after 15 minutes from creating"
      redirect_back(fallback_location: root_path)
    end
  end

  def set_post
    @post = Post.find(params[:id])
  end

  def set_user
    @user =  User.find(params[:user_id])
  end

  def post_params
    params.require(:post).permit(:desc)
  end
end

app/helpers/posts_helper.rb
module PostsHelper

  def check_for_subscribe(post)
    true if user_signed_in? && !current_user.followings.include?(post.user) && current_user != post.user
  end

  def check_for_unsubscribe(post)
    true if user_signed_in? && current_user.followings.include?(post.user)
  end

  def check_for_edit(post)
    true if user_signed_in? && current_user == post.user && Time.new < post.created_at + 15.minutes && !current_page?(edit_user_post_path(current_user, post))
  end

  def check_for_delete(post)
    true if user_signed_in? && current_user == post.user && !current_page?(edit_user_post_path(current_user, post))
  end



end

app/views/posts/_form.html.erb
<%= form_with(model: [current_user, @post], local: true) do |form| %>
<% if @post.images.attached? %>
<%= render @post %>
<% end %>

<% if post.errors.any? %>
<div id="error_explanation">
  <h2><%= pluralize(post.errors.count, "error") %> prohibited this post from being saved:</h2>
  <ul>
    <% post.errors.full_messages.each do |message| %>
    <li><%= message %></li>
    <% end %>
  </ul>
</div>
<% end %>

<% unless @post.id.nil? %>
<% if current_page?(edit_user_post_path(current_user, @post)) %>
<%= form.check_box :change_all %>
<%= form.label :change_all, 'Заменить картинки' %>
<% end %>
<% end %>

<div class="field">
  <%= form.label :images %>
  <%= form.file_field :images, multiple: true %>
</div>

<div class="field">
  <%= form.label :desc %>
  <%= form.text_area :desc, :class => 'form-control', rows: '5' %>
</div>

<div class="actions">
  <%= form.submit :class => 'btn btn-primary my-2' %>
</div>
<% end %>

app/views/posts/_post.html.erb
<div class="col-12 col-sm-10 col-md-8 m-auto">
  <div class="postSHowEach card">
    <div class="card-header fmy-card-header d-flex justify-content-between align-items-center <%= 'alreadySubscribe' if user_signed_in? && current_user.followings.include?(post.user) %>">
      <%= link_to post.user.login, user_path(post.user), :class => 'postOwnerLogin' %>
      <% if post.id %>
      <div class="dropdown">
        <%= link_to "s", '#', id: "dropdownMenuLink", data: { toggle: 'dropdown' } %>
        <div class="dropdown-menu fmy-dropdown-menu" aria-labelledby="dropdownMenuButton">
          <%= link_to 'Подписаться', follow_user_path(post.user), :class => 'dropdown-item', method: :post if check_for_subscribe(post) %>
          <%= link_to 'Отписаться', unfollow_user_path(post.user), :class => 'dropdown-item', method: :post if check_for_unsubscribe(post)%>
          <%= link_to 'Удалить', user_post_path(post.user, post), :class => 'dropdown-item', method: :delete if check_for_delete(post) %>
          <%= link_to 'Редактировать', edit_user_post_path(post.user, post), :class => 'dropdown-item' if check_for_edit(post)%>
          <%= link_to 'Просмотреть', user_post_path(post.user, post), :class => 'dropdown-item' %>
        </div>
      </div>
      <% end %>
    </div>
    <% if post.images.attached? %>
    <% if post.images.length > 1 %>
    <div class="slider">
      <% post.images.each do |image| %>
      <div class="fmy-slider-image"><%= image_tag image %></div>
      <% end %>
    </div>
    <% else %>
    <% unless post.images.first.id.nil? %>
    <div class="singleImage">
      <%= image_tag post.images.first %>
    </div>
    <% end %>
    <% end %>
    <% end %>
    <div>
      <% if user_signed_in? && post.id %>
      <%= link_to '+', up_post_likes_path(post), :class => 'likeUp', method: :post unless user_leave_like_to?(post) %>
      <%= link_to '-', down_post_likes_path(post), :class => 'likeDown', method: :delete if user_leave_like_to?(post) %>
      <span><%= post.likes.count %> likes</span>
      <% else %>
      <span class="likeUp"></span> <%= post.likes.count %> likes
      <% end %>
    </div>
    <% unless post.desc.empty? %>
    <div class="fmy-card-body">
      <p class="card-text"><%= post.desc %></p>
    </div>
    <% end %>
  </div>
</div>

app/views/posts/edit.html.erb
<h1>Editing Post</h1>

<%= render 'form', post: @post %>

app/views/posts/index.html.erb
<h1>Posts</h1>

<div class="row">
<%= render @posts %>
</div>

app/views/posts/new.html.erb
<h1>New Post</h1>

<%= render 'form', post: @post %>

app/views/posts/show.html.erb
<%= render @post %>
<% unless @comments.empty? %>
<h3 class="col-12 col-sm-10 col-md-8 m-auto">Comments:</h3>
<%= render @comments %>
<% end %>
<h3 class="col-12 col-sm-10 col-md-8 m-auto">Leave a comment:</h5>
<% if user_signed_in? %>
<%= render 'comments/form', comment: @comment %>
<% else %>
<div class="col-12 col-sm-10 col-md-8 m-auto py-5">
<h4>You are not log in! Please <%= link_to 'Log in', new_user_session_path %>, or <%= link_to 'Sign in', new_user_registration_path %></h4>
</div>
<% end %>

app/views/posts/subscriptions.html.erb
<h1>My subscriptions</h1>

<%= render @posts %>